Index: /CMT/v1r25-branch/ChangeLog
===================================================================
--- /CMT/v1r25-branch/ChangeLog	(revision 637)
+++ /CMT/v1r25-branch/ChangeLog	(revision 638)
@@ -1,2 +1,11 @@
+2013-01-11    <rybkin@lal.in2p3.fr> 499
+
+	* mgr/fragments/constituent: Remove unused code, add empty command for
+	double-colon rules without one (so that implicit rule is not searched for)
+	* mgr/fragments/constituent_lock: idem
+	* mgr/fragments/jar: Add empty command for double-colon rules without one (so that implicit rule is not searched for)
+	* mgr/fragments/java: Create necessary directory in compilation rule to
+	avoid race condition
+
 2013-01-03    <rybkin@lal.in2p3.fr> 498
 
Index: /CMT/v1r25-branch/mgr/fragments/constituent
===================================================================
--- /CMT/v1r25-branch/mgr/fragments/constituent	(revision 637)
+++ /CMT/v1r25-branch/mgr/fragments/constituent	(revision 638)
@@ -3,41 +3,18 @@
 cmt_${CONSTITUENT}_${HASTARGETTAG} = 1
 
-#--------------------------------------------------------
+#--------------------------------------
 
 ifdef cmt_${CONSTITUENT}_has_target_tag
 
-#cmt_local_tagfile_${CONSTITUENT} = $(${PACKAGE}_tag)_${CONSTITUENT}.make
 cmt_local_tagfile_${CONSTITUENT} = $(bin)$(${PACKAGE}_tag)_${CONSTITUENT}.make
-cmt_local_setup_${CONSTITUENT} = $(bin)setup_${CONSTITUENT}$$$$.make
 cmt_final_setup_${CONSTITUENT} = $(bin)setup_${CONSTITUENT}.make
-#cmt_final_setup_${CONSTITUENT} = $(bin)${PACKAGE}_${CONSTITUENT}setup.make
 cmt_local_${CONSTITUENT}_makefile = $(bin)${CONSTITUENT}.make
 
 ${CONSTITUENT}_extratags = -tag_add=target_${CONSTITUENT}
 
-#$(cmt_local_tagfile_${CONSTITUENT}) : $(cmt_lock_setup)
-ifndef QUICK
-$(cmt_local_tagfile_${CONSTITUENT}) ::
-else
-$(cmt_local_tagfile_${CONSTITUENT}) :
-endif
-	$(echo) "(constituents.make) Rebuilding $@"; \
-	  if test -f $(cmt_local_tagfile_${CONSTITUENT}); then /bin/rm -f $(cmt_local_tagfile_${CONSTITUENT}); fi ; \
-	  $(cmtexe) -tag=$(tags) $(${CONSTITUENT}_extratags) build tag_makefile >>$(cmt_local_tagfile_${CONSTITUENT})
-	$(echo) "(constituents.make) Rebuilding $(cmt_final_setup_${CONSTITUENT})"; \
-	  test ! -f $(cmt_local_setup_${CONSTITUENT}) || \rm -f $(cmt_local_setup_${CONSTITUENT}); \
-	  trap '\rm -f $(cmt_local_setup_${CONSTITUENT})' 0 1 2 15; \
-	  $(cmtexe) -tag=$(tags) $(${CONSTITUENT}_extratags) show setup >$(cmt_local_setup_${CONSTITUENT}) && \
-	  if [ -f $(cmt_final_setup_${CONSTITUENT}) ] && \
-	    \cmp -s $(cmt_final_setup_${CONSTITUENT}) $(cmt_local_setup_${CONSTITUENT}); then \
-	    \rm $(cmt_local_setup_${CONSTITUENT}); else \
-	    \mv -f $(cmt_local_setup_${CONSTITUENT}) $(cmt_final_setup_${CONSTITUENT}); fi
-
 else
 
-#cmt_local_tagfile_${CONSTITUENT} = $(${PACKAGE}_tag).make
 cmt_local_tagfile_${CONSTITUENT} = $(bin)$(${PACKAGE}_tag).make
 cmt_final_setup_${CONSTITUENT} = $(bin)setup.make
-#cmt_final_setup_${CONSTITUENT} = $(bin)${PACKAGE}setup.make
 cmt_local_${CONSTITUENT}_makefile = $(bin)${CONSTITUENT}.make
 
@@ -53,18 +30,4 @@
 ${CONSTITUENT}dirs : ;
 endif
-
-#ifndef QUICK
-#ifdef STRUCTURED_OUTPUT
-# ${CONSTITUENT}dirs ::
-#	@if test ! -d $(bin)${CONSTITUENT}; then $(mkdir) -p $(bin)${CONSTITUENT}; fi
-#	$(echo) "STRUCTURED_OUTPUT="$(bin)${CONSTITUENT}
-#
-#$(cmt_local_${CONSTITUENT}_makefile) :: $(${CONSTITUENT}_dependencies) $(cmt_local_tagfile_${CONSTITUENT}) build_library_links dirs ${CONSTITUENT}dirs
-#else
-#$(cmt_local_${CONSTITUENT}_makefile) :: $(${CONSTITUENT}_dependencies) $(cmt_local_tagfile_${CONSTITUENT}) build_library_links dirs
-#endif
-#else
-#$(cmt_local_${CONSTITUENT}_makefile) :: $(cmt_local_tagfile_${CONSTITUENT})
-#endif
 
 ifdef cmt_${CONSTITUENT}_has_target_tag
@@ -114,5 +77,5 @@
 	$(echo) "(constituents.make) ${CONSTITUENT} done"
 
-clean :: ${CONSTITUENT}clean
+clean :: ${CONSTITUENT}clean ;
 
 ${CONSTITUENT}clean :: $(${CONSTITUENT}clean_dependencies) ##$(cmt_local_${CONSTITUENT}_makefile)
@@ -126,5 +89,5 @@
 ##	  /bin/rm -f $(cmt_local_${CONSTITUENT}_makefile) $(bin)${CONSTITUENT}_dependencies.make
 
-install :: ${CONSTITUENT}install
+install :: ${CONSTITUENT}install ;
 
 ${CONSTITUENT}install :: $(${CONSTITUENT}_dependencies) $(cmt_local_${CONSTITUENT}_makefile)
@@ -145,5 +108,5 @@
 	$(echo) "(constituents.make) uninstall ${CONSTITUENT} done"
 
-remove_library_links :: ${CONSTITUENT}uninstall
+remove_library_links :: ${CONSTITUENT}uninstall ;
 
 ifndef PEDANTIC
Index: /CMT/v1r25-branch/mgr/fragments/constituent_lock
===================================================================
--- /CMT/v1r25-branch/mgr/fragments/constituent_lock	(revision 637)
+++ /CMT/v1r25-branch/mgr/fragments/constituent_lock	(revision 638)
@@ -7,37 +7,14 @@
 ifdef cmt_${CONSTITUENT}_has_target_tag
 
-#cmt_local_tagfile_${CONSTITUENT} = $(${PACKAGE}_tag)_${CONSTITUENT}.make
 cmt_local_tagfile_${CONSTITUENT} = $(bin)$(${PACKAGE}_tag)_${CONSTITUENT}.make
-cmt_local_setup_${CONSTITUENT} = $(bin)setup_${CONSTITUENT}$$$$.make
 cmt_final_setup_${CONSTITUENT} = $(bin)setup_${CONSTITUENT}.make
-#cmt_final_setup_${CONSTITUENT} = $(bin)${PACKAGE}_${CONSTITUENT}setup.make
 cmt_local_${CONSTITUENT}_makefile = $(bin)${CONSTITUENT}.make
 
 ${CONSTITUENT}_extratags = -tag_add=target_${CONSTITUENT}
 
-#$(cmt_local_tagfile_${CONSTITUENT}) : $(cmt_lock_setup)
-ifndef QUICK
-$(cmt_local_tagfile_${CONSTITUENT}) ::
-else
-$(cmt_local_tagfile_${CONSTITUENT}) :
-endif
-	$(echo) "(constituents.make) Rebuilding $@"; \
-	  if test -f $(cmt_local_tagfile_${CONSTITUENT}); then /bin/rm -f $(cmt_local_tagfile_${CONSTITUENT}); fi ; \
-	  $(cmtexe) -tag=$(tags) $(${CONSTITUENT}_extratags) build tag_makefile >>$(cmt_local_tagfile_${CONSTITUENT})
-	$(echo) "(constituents.make) Rebuilding $(cmt_final_setup_${CONSTITUENT})"; \
-	  test ! -f $(cmt_local_setup_${CONSTITUENT}) || \rm -f $(cmt_local_setup_${CONSTITUENT}); \
-	  trap '\rm -f $(cmt_local_setup_${CONSTITUENT})' 0 1 2 15; \
-	  $(cmtexe) -tag=$(tags) $(${CONSTITUENT}_extratags) show setup >$(cmt_local_setup_${CONSTITUENT}) && \
-	  if [ -f $(cmt_final_setup_${CONSTITUENT}) ] && \
-	    \cmp -s $(cmt_final_setup_${CONSTITUENT}) $(cmt_local_setup_${CONSTITUENT}); then \
-	    \rm $(cmt_local_setup_${CONSTITUENT}); else \
-	    \mv -f $(cmt_local_setup_${CONSTITUENT}) $(cmt_final_setup_${CONSTITUENT}); fi
-
 else
 
-#cmt_local_tagfile_${CONSTITUENT} = $(${PACKAGE}_tag).make
 cmt_local_tagfile_${CONSTITUENT} = $(bin)$(${PACKAGE}_tag).make
 cmt_final_setup_${CONSTITUENT} = $(bin)setup.make
-#cmt_final_setup_${CONSTITUENT} = $(bin)${PACKAGE}setup.make
 cmt_local_${CONSTITUENT}_makefile = $(bin)${CONSTITUENT}.make
 
@@ -53,18 +30,4 @@
 ${CONSTITUENT}dirs : ;
 endif
-
-#ifndef QUICK
-#ifdef STRUCTURED_OUTPUT
-# ${CONSTITUENT}dirs ::
-#	@if test ! -d $(bin)${CONSTITUENT}; then $(mkdir) -p $(bin)${CONSTITUENT}; fi
-#	$(echo) "STRUCTURED_OUTPUT="$(bin)${CONSTITUENT}
-#
-#$(cmt_local_${CONSTITUENT}_makefile) :: $(${CONSTITUENT}_dependencies) $(cmt_local_tagfile_${CONSTITUENT}) build_library_links dirs ${CONSTITUENT}dirs
-#else
-#$(cmt_local_${CONSTITUENT}_makefile) :: $(${CONSTITUENT}_dependencies) $(cmt_local_tagfile_${CONSTITUENT}) build_library_links dirs
-#endif
-#else
-#$(cmt_local_${CONSTITUENT}_makefile) :: $(cmt_local_tagfile_${CONSTITUENT})
-#endif
 
 ifdef cmt_${CONSTITUENT}_has_target_tag
@@ -129,5 +92,5 @@
 ##	  /bin/rm -f $(cmt_local_${CONSTITUENT}_makefile) $(bin)${CONSTITUENT}_dependencies.make
 
-install :: ${CONSTITUENT}install
+install :: ${CONSTITUENT}install ;
 
 ${CONSTITUENT}install :: $(${CONSTITUENT}_dependencies) $(cmt_local_${CONSTITUENT}_makefile)
@@ -148,5 +111,5 @@
 	$(echo) "(constituents.make) uninstall ${CONSTITUENT} done"
 
-remove_library_links :: ${CONSTITUENT}uninstall
+remove_library_links :: ${CONSTITUENT}uninstall ;
 
 ifndef PEDANTIC
Index: /CMT/v1r25-branch/mgr/fragments/jar
===================================================================
--- /CMT/v1r25-branch/mgr/fragments/jar	(revision 637)
+++ /CMT/v1r25-branch/mgr/fragments/jar	(revision 638)
@@ -8,7 +8,7 @@
 ${CONSTITUENT}installname = ${CONSTITUENT}.jar
 
-${CONSTITUENT} :: ${CONSTITUENT}install
+${CONSTITUENT} :: ${CONSTITUENT}install ;
 
-install :: ${CONSTITUENT}install
+install :: ${CONSTITUENT}install ;
 
 ${CONSTITUENT}install :: $(install_dir)/$(${CONSTITUENT}installname)
@@ -29,5 +29,5 @@
 ##${CONSTITUENT}clean :: ${CONSTITUENT}uninstall
 
-uninstall :: ${CONSTITUENT}uninstall
+uninstall :: ${CONSTITUENT}uninstall ;
 
 ${CONSTITUENT}uninstall ::
@@ -41,6 +41,6 @@
 
 ${CONSTITUENT}clean ::
-	$(cleanup_silent) /bin/rm -rf $(javabin)/${CONSTITUENT}
-	$(cleanup_silent) /bin/rm -f $(javabin)/${CONSTITUENT}.jar
+	$(cleanup_silent) /bin/rm -rf $(javabin)${CONSTITUENT}
+	$(cleanup_silent) /bin/rm -f $(javabin)${CONSTITUENT}.jar
 
 #-- end of jar ------
Index: /CMT/v1r25-branch/mgr/fragments/java
===================================================================
--- /CMT/v1r25-branch/mgr/fragments/java	(revision 637)
+++ /CMT/v1r25-branch/mgr/fragments/java	(revision 638)
@@ -3,5 +3,6 @@
 ${OUTPUTNAME} : ${FULLNAME}
 	$(java_echo) $@
-	$(java_silent)cd $(src); $(javacomp) -d $(javabin)/${CONSTITUENT} $(use_javaflags) $(${CONSTITUENT}_javaflags) $(${NAME}_javaflags) ${FULLNAME}
+	$(java_silent) [ -d $(javabin)${CONSTITUENT} ] || $(mkdir) -p $(javabin)${CONSTITUENT}
+	$(java_silent)cd $(src); $(javacomp) -d $(javabin)${CONSTITUENT} $(use_javaflags) $(${CONSTITUENT}_javaflags) $(${NAME}_javaflags) ${FULLNAME}
 
 #-- end of java ------